<template>
  <div>
    <b-container fluid>
      <b-row>
        <b-col class="text-right">
          <ProductForm
            :product="selectedItem"
            ref="productForm"
            @save="saveProduct"
          ></ProductForm>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <b-table :items="productItems" :fields="fields">
            <template #cell(price)="{ item }">
              ฿{{ item.price.toFixed(2).replace(/\d(?=(\d{3})+\.)/g, '$&,') }}
            </template>
            <template #cell(operators)="{ item }">
              <b-button @click="editProduct(item)">แก้ไข</b-button
              ><b-button
                @click="deleteProduct(item)"
                class="ml-1"
                variant="danger"
                >ลบ</b-button
              >
            </template>
          </b-table>
        </b-col>
      </b-row>
    </b-container>
  </div>
</template>
<script>
import ProductForm from './ProductForm.vue'
import axios from 'axios'
export default {
  components: {
    ProductForm
  },
  methods: {
    saveProduct (product) {
      console.log('Submit', product)
      if (product._id === '') { // Add New
        axios.post('http://localhost:3000/products', product).then(
          function (response) {
            const newProduct = response.data
            console.log(response)
            this.getProducts()
            this.makeToast('เพิ่มสำเร็จ', 'สินค้า ' + newProduct._id + ' ถูกเพิ่มแล้ว')
          }.bind(this)
        ).catch(() => {
          this.makeToast('เพิ่มไม่สำเร็จ', 'ไม่สามรถเพิ่ม ' + product._id, 'danger')
        })
      } else { // Update
        axios.put('http://localhost:3000/products/' + product._id, product).then(
          function (response) {
            const updateProduct = response.data
            this.getProducts()
            this.makeToast('ปรับปรุงสำเร็จ', 'สินค้า ' + updateProduct._id + ' ถูกแก้ไขแล้ว')
          }.bind(this)
        ).catch(() => {
          this.makeToast('ปรับปรุงไม่สำเร็จ', 'ไม่สามรถปรับปรุง ' + product._id)
        })
      }
    },
    editProduct (item) {
      this.selectedItem = JSON.parse(JSON.stringify(item))
      this.$nextTick(() => {
        this.$refs.productForm.show()
      })
    },
    deleteProduct (product) {
      if (confirm(`คุณต้องการจะลบสินค้า ${product._id} หรือไม่`)) {
        axios.delete('http://localhost:3000/products/' + product._id).then(
          function (response) {
            this.getProducts()
            this.makeToast('ลบสำเร็จ', 'สินค้า ' + product._id + ' ถูกลบแล้ว')
          }.bind(this)
        ).catch(() => {
          this.makeToast('ลบไม่สำเร็จ', 'ไม่สามรถลบ ' + product._id)
        })
      }
    },
    getProducts () {
      const self = this
      axios.get('http://localhost:3000/products').then((response) => {
        console.log(response)
        self.productItems = response.data
      })
    },
    makeToast (title, message, variant = 'success', append = false) {
      this.toastCount++
      this.$bvToast.toast(message, {
        title: title,
        variant: variant,
        autoHideDelay: 3000,
        appendToast: append
      })
    }
  },
  data () {
    return {
      fields: [
        { key: '_id', label: 'ไอดี' },
        { key: 'name', label: 'ชื่อสินค้า' },
        { key: 'price', label: 'ราคา' },
        { key: 'operators', label: 'กระบวนการ' }
      ],
      productItems: [],
      selectedItem: null,
      productId: 11
    }
  },
  mounted () {
    this.getProducts()
  }
}
</script>
<style></style>
